package edu.mermet.tp8.fenetres;

import javax.swing.*;
import javax.swing.text.html.HTMLEditorKit;
import java.awt.*;
import java.util.HashMap;
import java.util.ResourceBundle;
import java.util.Set;
import java.util.Vector;

public class Aide extends JDialog {
    private ResourceBundle bundleTitres = ResourceBundle.getBundle("HowTo/titres");
    private ResourceBundle bundleTextes = ResourceBundle.getBundle("HowTo/textes");

    private HashMap<String,String> mapTitreToCle;

    private JList listTitres;

    private JEditorPane affichageTexte;

    public Aide(JFrame parent) {
        super(parent, "Comment faire ?", false);

        init();

        add(new JSplitPane(JSplitPane.HORIZONTAL_SPLIT, true, listTitres, affichageTexte));

        pack();

        setDefaultCloseOperation(DISPOSE_ON_CLOSE);
        setLocationRelativeTo(parent);
    }

    private void init() {
        mapTitreToCle = new HashMap<>();

        Set<String> keySet = bundleTitres.keySet();

        Vector<String> titres = new Vector<>();

        for (String key : keySet) {
            titres.add(bundleTitres.getString(key));
            mapTitreToCle.put(bundleTitres.getString(key), key);
        }

        listTitres = new JList(titres);
        listTitres.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        listTitres.setSelectedIndex(0);

        listTitres.addListSelectionListener(se -> {
            affichageTexte.setText(bundleTextes.getString(mapTitreToCle.get(listTitres.getSelectedValue())));
        });

        add(listTitres);


        affichageTexte = new JEditorPane();
        affichageTexte.setEditable(false);
        affichageTexte.setPreferredSize(new Dimension(300,250));
        affichageTexte.setEditorKit(new HTMLEditorKit());
        affichageTexte.setText(bundleTextes.getString(keySet.iterator().next()));

        add(affichageTexte);
    }
}
